//+------------------------------------------------------------------+
//|                                                    TickValue.mq4 |
//|                                         Copyright  2007, Xupypr |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Xupypr"
#property show_inputs

#include <WinUser32.mqh>

extern double Lots=1.0; //  

string Symbols[24]={"CHFJPY","CADJPY","CADCHF","USDJPY","USDCHF","USDCAD","EURUSD","EURGBP","EURJPY","EURCHF","EURAUD","EURCAD","EURNZD","GBPUSD","GBPJPY","GBPCHF","NZDUSD","NZDJPY","AUDUSD","AUDJPY","AUDCHF","AUDCAD","AUDNZD","GOLD"};

int start()
{
 if (!IsConnected())
 {
  MessageBox("     \t","!",MB_OK|MB_ICONERROR);
  return(-1);
 }
 if (Lots<MarketInfo(Symbol(),MODE_MINLOT)) Lots=MarketInfo(Symbol(),MODE_MINLOT);
 if (Lots>MarketInfo(Symbol(),MODE_MAXLOT)) Lots=MarketInfo(Symbol(),MODE_MAXLOT);
 string str="\t\t\t\t\t\n\n";
 for (int i=0;i<24;i++) str=StringConcatenate(str,Symbols[i],"\t\t",Lots*MarketInfo(Symbols[i],MODE_POINT)*TickValue(Symbols[i]),"\t\t",
                                                                    Lots*MarketInfo(Symbols[i],MODE_TICKVALUE),"\n");
 MessageBox(str," ",MB_OK|MB_ICONINFORMATION);
 return(0);
}
//+----------------------------------------------------------------------------+
//|                                                  |
//+----------------------------------------------------------------------------+
double TickValue(string symbol)
{
 double size=MarketInfo(symbol,MODE_LOTSIZE);
 if (MarketInfo(symbol,MODE_PROFITCALCMODE)==0)
 {
  if (StringSubstr(symbol,3,3)=="USD") return(size);
  if (StringSubstr(symbol,0,3)=="USD") size=size/iClose(symbol,0,0);
  else
  {
   string BQ=StringSubstr(symbol,0,3)+"USD";
   if (iClose(BQ,0,0)==0) BQ="USD"+StringSubstr(symbol,0,3);
   if (iClose(BQ,0,0)==0) return(size);
   if (StringSubstr(BQ,0,3)=="USD") size=size/iClose(BQ,0,0)/iClose(symbol,0,0);
   else size=size*iClose(BQ,0,0)/iClose(symbol,0,0);
  }
 }
 return(size);
}
//+----------------------------------------------------------------------------+